/*
 * xhime  -  Himechan for X Window System
 * Copyright(C) 1994-1996,1998 `Shochan'Shoichi-NAKAYAMA (PED02616@nifty.ne.jp)
 *
 *	Original version for PC-9801  "Resident Himechan Ver1.10"
 *	Copyright(C) 1994 MSP-Iris(Mapletown Network: MAP4370)
 */
static char rcsid[] ="$Header: /home/naka/xhime/xhime1.51/RCS/xhime.c,v 1.42 1998/09/11 11:57:51 naka Exp $";

char
*Copyright = "xhime version 1.51 by `Shochan' Shoichi-NAKAYAMA (C) 1994-1996,1998\n  Original: `rhime.exe' by MSP-Iris (C) 1994\n";

#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include	<X11/keysym.h>
#include	<X11/Xos.h>

#ifdef	SHAPE
#include	<X11/extensions/shape.h>
#endif/*SHAPE*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<signal.h>
#include	<ctype.h> /* defined in X11/Xos.h ? */
#include	<string.h>/* defined in X11/Xos.h ? */
#include	<limits.h>
#include	<varargs.h>
#include	<sys/time.h>/* defined in X11/Xos.h */
#include	<sys/types.h>
#include	<sys/stat.h>
#ifndef	O_RDONLY
#include	<fcntl.h>
#endif/*!O_RDONLY*/

#define	DOUBLEQUOTE	'\"'	/* " <- for hilit comment (^^ */

#ifndef	MIN
#define	MIN(a, b)	((a)<(b) ? (a):(b))
#endif/*!MIN*/

#ifndef	MAX
#define	MAX(a, b)	((a)>(b) ? (a):(b))
#endif/*!MAX*/

#ifndef MAILSPOOL_PATH
#define MAILSPOOL_PATH	"/usr/spool/mail/"
#endif/*!MAILSPOOL_PATH*/

#ifndef AUDIO_DEVICE
#define AUDIO_DEVICE	"/dev/audio"
#endif/*!AUDIO_DEVICE*/

#define	AUD_NONE	0
#define	AUD_BELL	1
#define	AUD_DEV		2
#define	AUD_CMD		3

#ifndef XHIMEDAT_PATH
#define	XHIMEDAT_PATH	"/usr/X11R6/lib/X11/xhime"
#endif/*!XHIMEDAT_PATH*/

char	*XHIMEDAT = XHIMEDAT_PATH;
char	*DisplayName = "";
char	*ProgramName = NULL;
char	*Geometry = NULL;
char	*DataName = "rh110.xhm";
char	*ActionKey = "Return";
char	*AudioCommand = "showaudio";
char	*AudioDevice = AUDIO_DEVICE;
char	*AudioDataName = "IKEIKE_J.au";
char	AudioDataPath[256] = "";
char	*Background = "black";
char	*MailPathArg = NULL;
Bool	Debug = False;
Bool	NoShape = False;
Bool	UseWM = False;
Bool	Rhime = True;
Bool	Biff = False;
int	Audio = AUD_NONE;
int	ActionState = 1;
int	MAX_AUSIZE = 65536;
Bool	FocusDebug = False;

#define	DEF_INT_TIME_MS	125
#define	DEF_MAIL_CHECK_INT_TIME_MS	30000	/* 30sec. */
#define	FOCUS_CHECK_INTERVAL_TIME_MS	500
int	MAIL_CHECK_INTERVAL_TIME_MS = DEF_MAIL_CHECK_INT_TIME_MS;
int	INTERVAL_TIME_MS = DEF_INT_TIME_MS;
int	FocusCheckCountMax = FOCUS_CHECK_INTERVAL_TIME_MS / DEF_INT_TIME_MS;
int	MailCheckCountMax  = DEF_MAIL_CHECK_INT_TIME_MS   / DEF_INT_TIME_MS;
int	NCOLORS, NCELLS, NPATTERNS, NSTATES;
int	WIDTH, HEIGHT;

#define	H_OFF	0	/*window height OFFSET no use*/
#define	MOVECHECK_MASK	0
/*#define	MOVECHECK_MASK	(UseWM ? StructureNotifyMask : 0)*/
#define	EVENT_MASK	(KeyPressMask|ButtonPressMask|ButtonReleaseMask|PointerMotionMask|MOVECHECK_MASK)
#define	FOCUS_EVENT_MASK	(KeyPressMask|StructureNotifyMask)

Display		*MyDisplay;
int		MyScreen;
unsigned int	MyDepth;
Window		MyWindow;
int		Myx, Myy;
KeySym	ActionKeysym;

#define	IDLE	0
#define	ACTION	1
int	State = IDLE;
int	PatternNumber = 0;
#define	ACT_NONE	0
#define	ACT_KEY		1
#define	ACT_MAIL	2
int	ActionFlag = ACT_NONE;

/* -- */
void
Error(va_alist)
     va_dcl
{
  va_list	args;
  char	*fmt;

  fprintf(stderr, "%s: ", ProgramName);

  va_start(args);
  fmt = (char *)va_arg(args, char *);
  vfprintf(stderr, fmt, args);
  va_end(args);

  fprintf(stderr, "\n");
}

void
ErrorExit(va_alist)
     va_dcl
{
  va_list	args;
  char	*fmt;

  fprintf(stderr, "%s: ", ProgramName);

  va_start(args);
  fmt = (char *)va_arg(args, char *);
  vfprintf(stderr, fmt, args);
  va_end(args);

  fprintf(stderr, "\n");
  exit(1);
}

#define CALLOC(p, nelem, elsize)        \
  do {\
    if (p) ErrorExit("not null pointer");\
    if ((nelem)*(elsize) > 0) {\
      if (! ((p) = (void *)calloc((unsigned)(nelem), (unsigned)(elsize))) )\
        ErrorExit("cannot alocate memory");\
    }else {\
      ErrorExit("invalid memory size '%d'", (nelem)*(elsize));\
    }\
  } while (0)

#define	FREE(p)	do {if (p) { free(p); (p) = NULL; } } while (0)

#ifdef	GET_DEBUG
#define	DEBUG_PUTC(c)	putchar(c)
#define	DEBUG_PUTS(c)	fputs(c, stdout)
#else
#define	DEBUG_PUTC(c)
#define	DEBUG_PUTS(c)
#endif/*GET_DEBUG*/

typedef	struct {
  char	name[256];
  int	x;
  int	y;
  int	nmask;
  int	*mask_num;
  int	width;
  int	height;
  char	**pxl;
  Pixmap	pixmap;
  Pixmap	mask;
}CELL;

CELL	*Cell = NULL;

typedef	struct {
  char	c;
  char	type[3];
  char	name[256];
  GC	GC;
}COLOR;

COLOR	*DummyColor = NULL;
COLOR	*ColorN = NULL;
COLOR	*ColorD = NULL;
COLOR	*ColorB = NULL;
COLOR	**Color = &ColorN;

typedef	struct {
  int	num;
  int	x;
  int	y;
}PATTERN;

PATTERN	*Pattern = NULL;

typedef	struct {
  int	start;
  int	end;
  int	next_state;
}STATES;

STATES	*States = NULL;


int
Skip(fp)
     FILE	*fp;
{
  int	flg = 1, c;

  DEBUG_PUTC('<');
  while (EOF != (c = getc(fp))) {
    DEBUG_PUTC(c);
    if (isspace(c)) continue;
    if (c == ',' && flg) {
      flg = 0;
      continue;
    }
    break;
  }
  DEBUG_PUTC('>');

  if (c == EOF) ErrorExit("eof");

  ungetc(c, fp);
  return (c);
}

int
Found(fp, f)
     FILE	*fp;
     int	f;
{
  int	c;

  while (EOF != (c = getc(fp)) && c != f);
  if (c == EOF) {
    ErrorExit("not found char '%c'", f);
  }
  return (c);
}

int
GetStr(fp, str, len)
     FILE	*fp;
     char	*str;
     int	len;
{
  int	i = 0, c;

  DEBUG_PUTC('<');
  while (EOF != (c = getc(fp))) {
    DEBUG_PUTC(c);
    if (isspace(c) || c == ',' || c == DOUBLEQUOTE) break;
    if (i++ < len - 1) {
      *str++ = c;
    }
  }
  DEBUG_PUTC('>');

  if (c == EOF) ErrorExit("not found string");

  ungetc(c, fp);
  *str = '\0';
  return (c);
}

int
GetInt(fp, value)
     FILE	*fp;
     int	*value;
{
  char	buf[24];
  int	c = GetStr(fp, buf, sizeof(buf));
  *value = atoi(buf);
  return (c);
}

int
GetDefinedInt(fp, msg)
     FILE	*fp;
     char	*msg;
{
  static char	define[] = "#define";
  char	line[256];
  int	value;

  for (;;) {
    if (!fgets(line, sizeof(line), fp)) {
      ErrorExit("not found #define");
    }

    if (strncmp(line, define, sizeof(define)-1) == 0) {
      if (sscanf(line, "#define %*s %d", &value) != 1) {
	ErrorExit("cannot read '%s'", msg);
      }

      if (Debug) printf("%s = %d\n", msg, value);
      break;
    }
  }
  return (value);
}

void
GetColor(fp, color, ncolors)
     FILE	*fp;
     COLOR	*color;
     int	ncolors;
{
  int	i;

  for (i = 0; i < ncolors; i++, color++) {
    Found(fp, DOUBLEQUOTE);
    if ((color->c = getc(fp)) == EOF) ErrorExit("eof");
    Skip(fp);
    GetStr(fp, color->type, sizeof(color->type));
    Skip(fp);
    GetStr(fp, color->name, sizeof(color->name));
    Found(fp, DOUBLEQUOTE);

    if (Debug) printf("%c %s %s\n", color->c, color->type, color->name);
  }
}

int
GetXpm(fp, cell, color)
     FILE	*fp;
     CELL	*cell;
     COLOR	*color;
{
  static char	XPM[] = "/* XPM */";
  int	ncolors, chars_per_pixel;
  char	**yp = NULL;
  char	line[80];
  int	x, y;

  for (;;) {
    if (!fgets(line, sizeof(line), fp)) {
      ErrorExit("not found XPM header");
    }
    if (strncmp(line, XPM, sizeof(XPM)-1) == 0) break;
  }
  Found(fp, '{');
  Found(fp, DOUBLEQUOTE);
  GetInt(fp, &cell->width);	Skip(fp);
  GetInt(fp, &cell->height);	Skip(fp);
  GetInt(fp, &ncolors);	Skip(fp);
  GetInt(fp, &chars_per_pixel);
  if (Debug) printf("width=%d, height=%d, ncolors=%d, %d(chars/pixel)\n",
		    cell->width, cell->height, ncolors, chars_per_pixel);
  if (chars_per_pixel != 1) {
    ErrorExit("not supported XPM (chars/pixel != 1)");
  }
  Found(fp, DOUBLEQUOTE);

  CALLOC(color, ncolors, sizeof(*color));
  GetColor(fp, color, ncolors);

  CALLOC(cell->pxl, cell->height, sizeof(cell->pxl));
  yp = cell->pxl;
  for (y = 0; y < cell->height; y++, yp++) {
    char	*xp = NULL;

    Found(fp, DOUBLEQUOTE);
    CALLOC(*yp, cell->width + 1, sizeof(char));
    xp = *yp;
    for (x = 0; x < cell->width; x++) {
      int c = getc(fp);
      if (EOF == c) ErrorExit("eof");
      DEBUG_PUTC(c);
      *xp++ = c;
    }
    Found(fp, DOUBLEQUOTE);
    DEBUG_PUTC('\n');
  }
  Found(fp, '}');

  return (ncolors);
}

char OpenDataName[256] = "";
#define	STR_TAIL(p)	(*(p) ? *((char *)(p) + strlen(p) - 1): *(p) )

FILE*
OpenData(fname, mode)
     char	*fname;
     char	*mode;
{
  FILE	*fp = stdin;
  strncpy(OpenDataName, fname, sizeof(OpenDataName));
  if (strcmp(fname, "-") != 0) {
    if (Debug) fprintf(stderr, "Data Searching...\n\tCurrent  '%s'\n", fname);
    if ((fp = fopen(fname, mode)) == NULL) {
      if (*fname == '/' ) {
	ErrorExit("cannot open file '%s'", fname);
      }else {
	char path[256];
	strncpy(path, fname, sizeof(path));
	if (XHIMEDAT) {
	  strncpy(path, XHIMEDAT, sizeof(path));
	  if (STR_TAIL(path) != '/') strncat(path, "/", sizeof(path));
	  strncat(path, fname, sizeof(path));
	  fp = fopen(path, mode);
	  if (Debug) fprintf(stderr, "\tXHIMEDAT '%s'\n", path);
	}
	if (fp == NULL && strrchr(ProgramName, '/') != NULL) {
	  strncpy(path, ProgramName, sizeof(path));
	  *(strrchr(path, '/') + 1) = '\0';
	  strncat(path, fname, sizeof(path));
	  fp = fopen(path, mode);
	  if (Debug) fprintf(stderr, "\tProgram  '%s'\n", path);
	}
	if (fp == NULL) {
	  ErrorExit("cannot open file '%s'", path);
	}
	strncpy(OpenDataName, path, sizeof(OpenDataName));
      }
    }
  }
  return (fp);
}



int
GetData(fname)
     char	*fname;
{
  FILE	*fp = NULL;
  char	buf[256];
  int	c, i, j;
  char  *s = (char *)getenv("XHIMEDAT");

  if (s) XHIMEDAT = s;
  fp = OpenData(fname, "r");

  if (!fgets(buf, sizeof(buf), fp)) {
    ErrorExit("cannot read");
  }
  if (strncmp(buf, "/* xhime */", 11) != 0) {
    ErrorExit("not found xhime header");
  }

  NCOLORS = GetDefinedInt(fp, "NCOLORS");
  CALLOC(ColorN, NCOLORS, sizeof(*ColorN));
  CALLOC(ColorB, NCOLORS, sizeof(*ColorB));
  CALLOC(ColorD, NCOLORS, sizeof(*ColorD));

  GetColor(fp, ColorN, NCOLORS);
  GetColor(fp, ColorB, NCOLORS);
  GetColor(fp, ColorD, NCOLORS);

  WIDTH = GetDefinedInt(fp, "WIDTH");
  HEIGHT = GetDefinedInt(fp, "HEIGHT");
  NCELLS = GetDefinedInt(fp, "NCELLS");
  CALLOC(Cell, NCELLS, sizeof(*Cell));
  {
    CELL	*clp = Cell;
    Found(fp, '{');
    for (i = 0; i < NCELLS; i++, clp++) {
      Found(fp, DOUBLEQUOTE);
      GetStr(fp, clp->name, sizeof(clp->name));    Skip(fp);
      GetInt(fp, &clp->x);	Skip(fp);
      GetInt(fp, &clp->y);	c = Skip(fp);

      if (Debug) printf("%d: %s (%d,%d) ", i, clp->name, clp->x, clp->y);

      if (c != DOUBLEQUOTE) {
	int	*mp;

	CALLOC(clp->mask_num, NCELLS, sizeof(clp->mask_num));

	mp = clp->mask_num;
	for (j = 0; j < NCELLS; j++, mp++) {
	  if (c == DOUBLEQUOTE) break;

	  GetInt(fp, mp);	c = Skip(fp);
	  if (*mp < 0 || NCELLS <= *mp) {
	    ErrorExit("mask number error '%d'", *mp);
	  }
	  if (Debug) printf(" %d", *mp);
	}
	clp->nmask = j;
      }
      if (Debug) printf("\n");
      Found(fp, DOUBLEQUOTE);
    }
  }

  if ((INTERVAL_TIME_MS = GetDefinedInt(fp, "INTERVAL_TIME_MS") ) <= 0) {
    ErrorExit("invalid INTERVAL_TIME_MS number");
  }
  NPATTERNS = GetDefinedInt(fp, "NPATTERNS");
  if (NPATTERNS <= 0) {
    ErrorExit("invalid NPATTERNS number");
  }

  CALLOC(Pattern, NPATTERNS, sizeof(*Pattern));
  {
    PATTERN	*pp = Pattern;
    Found(fp, '{');
    for (i = 0; i < NPATTERNS; i++, pp++) {
      Found(fp, '{');    Skip(fp);
      GetInt(fp, &pp->num);	Skip(fp);
      GetInt(fp, &pp->x);	Skip(fp);
      GetInt(fp, &pp->y);

      if (Debug) printf("%d %d %d\n", pp->num, pp->x, pp->y);
      if (pp->num < 0 || NCELLS <= pp->num) {
	ErrorExit("invalid cell number '%d'", pp->num);
      }
    }
  }

  NSTATES = GetDefinedInt(fp, "NSTATES");
  CALLOC(States, NSTATES, sizeof(*States));
  {
    STATES	*sp = States;
    Found(fp, '{');
    for (i = 0; i < NSTATES; i++, sp++) {
      Found(fp, '{');    Skip(fp);
      GetInt(fp, &sp->start);	Skip(fp);
      GetInt(fp, &sp->end);	Skip(fp);
      GetInt(fp, &sp->next_state);

      if (Debug) printf("%d %d %d\n", sp->start, sp->end, sp->next_state);

      if (sp->start < 0 || NPATTERNS <= sp->start) {
	ErrorExit("invalid pattern number '%d'", sp->start);
      }
      if (sp->end < 0 || sp->end < sp->start) {
	ErrorExit("invalid pattern number '%d'", sp->end);
      }
      if (sp->next_state < 0 || NSTATES <= sp->next_state) {
	ErrorExit("invalid state number '%d'", sp->next_state);
      }
    }
    if (ActionState >= NSTATES) ActionState = 0;
  }

  {
    CELL	*clp = Cell;
    for (j = 0; j < NCELLS; j++, clp++) {
      FILE	*fpx = fp;

      if (strcmp(clp->name, "-") != 0) {
	fpx = OpenData(clp->name, "r");
      }
      if (Debug) printf("%d: xpmfile='%s'\n", j, clp->name);
      if (GetXpm(fpx, clp, DummyColor) != NCOLORS) {
	ErrorExit("invalid ncolors '%s'", clp->name);
      }
      FREE(DummyColor);
      if (fpx != fp) fclose(fpx);
    }
  }

  if (fp != stdin) fclose(fp);
}
/* -- */
char	MailPath[256] = MAILSPOOL_PATH;

void
GetMailPath()
{
  if (MailPathArg) {
    strncpy(MailPath, MailPathArg, sizeof(MailPath));
  }else if (getenv("MAIL")) {
    strncpy(MailPath, (char *)getenv("MAIL"), sizeof(MailPath));
  }else {
    if (STR_TAIL(MailPath) != '/') strncat(MailPath, "/", sizeof(MailPath));
    strncat(MailPath, (char *)getenv("USER"), sizeof(MailPath));
  }
  if (Debug) fprintf(stderr, "MailPath '%s'\n", MailPath);
}

Bool
CheckMail()
{
  static int	mail_size = 0;
  struct stat	f_stat;

  if (stat(MailPath, &f_stat) == 0) {
    if (f_stat.st_size != mail_size && f_stat.st_size != 0) {
      mail_size = f_stat.st_size;
      if (Debug) fprintf(stderr, "mail arrived\n");
      return (True);
    }
  }
  return (False);
}
/* -- */
char	*Au;
int	Ausize = 0;

void
ReadAudioFile()
{
  if (Audio == AUD_DEV || Audio == AUD_CMD) {
    FILE	*fp = OpenData( AudioDataName, "r");

    strncpy(AudioDataPath, OpenDataName, sizeof(AudioDataPath));
    if (Audio == AUD_DEV) {
      CALLOC(Au, MAX_AUSIZE, sizeof(*Au));
      Ausize = fread(&Au[0], 1, MAX_AUSIZE, fp);
      if (Debug) fprintf( stderr, "Ausize = %d\n", Ausize );
    }
    fclose(fp);
  }
}

void
PlayAudioFile()
{
  int	pid;
  if (Audio == AUD_BELL) {
    if (ActionFlag == ACT_MAIL)	XBell(MyDisplay, 0);
  }else if ((pid = fork()) == 0) {
    signal(SIGALRM, SIG_IGN);
    if (Audio == AUD_CMD) {
      if (execlp(AudioCommand, AudioDataPath, AudioDataPath, NULL) == -1) {
	Error("cannot exec '%s %s'", AudioCommand, AudioDataPath);
      }
    }else if (Audio == AUD_DEV) {
      FILE	*fpau = fopen(AudioDevice, "wb+");
      if (fpau) {
	fwrite(&Au[0], 1, Ausize, fpau);	fflush(fpau); fclose(fpau);
      }else {
	Error("cannot open file '%s'", AudioDevice);
      }
      FREE(Au);
    }
    _exit(0);
  }else if (pid < 0) {
    Error("cannot fork");
  }else {
    /* wait() in ResetChild() ^^; */
  }
}
/* -- */

int
SetMask(cell, xbm, width, height)
     CELL	*cell;
     unsigned char	*xbm;
     unsigned int	width, height;
{
  static unsigned char BITON[] = {0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0};
  int	w = cell->width;
  int	h = cell->height;
  int	xs = cell->x;
  int	ys = cell->y;
  char	**yp = cell->pxl;
  int	x, y, i;

  xbm += ((ys*width/8) + xs/8);
  for (y = ys; y < ys+h; y++, yp++) {
    unsigned char	*xbm_back = xbm;
    char *xp = *yp;
    for (x = xs; x < xs+w; x+=8) {
      unsigned char	c = 0;
      for (i = 0; i < 8; i++) {
	c |= (BITON[ (*xp != ' ') ? i : 8 ]);
	xp++;
      }
      *xbm++ = c;
    }
    xbm = xbm_back + (width/8);
  }
}

int
GetPointerPosition(win, x, y)
     Window	win;
     int	*x, *y;
{
  Window	root, child;
  int	wx, wy;
  unsigned int	key;

  return (XQueryPointer(MyDisplay, win, &root, &child, x, y, &wx, &wy, &key));
}

int
GetPixelIndex(color, ncolors, c)
     COLOR	*color;
     int	ncolors;
     char	*c;
{
  int	i;
  for (i = 0; i < ncolors; i++) {
    if (color[i].c == *c) return (i);
  }
  return (-1);
}

void
MakePixmap()
{
  XGCValues	GCValues;
  char	*xbm = NULL;
  int	xbm_size = ((WIDTH+7)/8)*HEIGHT;
  int	i;

  CALLOC(xbm, xbm_size, sizeof(*xbm));

  GCValues.function   = GXcopy;
  GCValues.fill_style = FillTiled;

  for (i = 0; i < NCELLS; i++) {
    CELL	*clp = &Cell[i];
    int	width = clp->width;
    int	height = clp->height;
    char **yp = clp->pxl;
    int	x, y;

    clp->pixmap = XCreatePixmap(MyDisplay, MyWindow, width, height, MyDepth);

    for (y = 0; y < height; y++, yp++) {
      char *xp = *yp;
      for (x = 0; x < width; x++, xp++) {
	int	c = GetPixelIndex(*Color, NCOLORS, xp);
	if (c == -1) {
	  ErrorExit("invalid pixel char '%c'", *xp);
	}
	XDrawPoint(MyDisplay, clp->pixmap, (*Color + c)->GC, x, y);
      }
    }

#ifdef	SHAPE
    if (!NoShape) {
      int	*mp = clp->mask_num, k;
      for (k = 0; k < xbm_size; k++) xbm[k] = 0;
      for (k = 0; k < clp->nmask; k++, mp++) {
	SetMask(&Cell[*mp], xbm, WIDTH, HEIGHT);
      }
      SetMask(clp, xbm, WIDTH, HEIGHT);
      clp->mask = XCreateBitmapFromData(MyDisplay, MyWindow, xbm,
					WIDTH, HEIGHT);
    }
#endif/*SHAPE*/
  }
  FREE(xbm);
}

Bool
Draw(no)
     int	no;
{
  static int	no_back = -1;
  Bool	flag = (no_back != no);
  int	offset_x = 0, offset_y = 0;
  static int	ptx_back = -1, pty_back = -1;

  if (UseWM) {
    if (   ptx_back != Pattern[PatternNumber].x
	|| pty_back != Pattern[PatternNumber].y) {
      ptx_back = Pattern[PatternNumber].x;
      pty_back = Pattern[PatternNumber].y;
      flag = True;
    }
    offset_x = ptx_back;
    offset_y = pty_back + H_OFF;
  }

  if (flag) {
    CELL	*clp = &Cell[no];

#ifdef	SHAPE
    if (!NoShape) {
      XShapeCombineMask(MyDisplay, MyWindow, ShapeBounding,
			offset_x, offset_y, clp->mask, ShapeSet);
    }
#endif/*SHAPE*/

    XCopyArea(MyDisplay, clp->pixmap, MyWindow, (*Color)->GC,
	      0, 0, clp->width, clp->height,
	      offset_x + clp->x, offset_y + clp->y);
    no_back = no;
  }
  return (flag);
}

void
DrawPattern()
{
  static int	ptx_back = -1, pty_back = -1;
  Bool	flush;
  STATES	*sp = &States[State];

  if (State == IDLE) {
    if (ActionFlag) {
      if (Audio) PlayAudioFile();
      ActionFlag = ACT_NONE;
      State = ActionState;
      PatternNumber = States[State].start;
    }else if (PatternNumber > sp->end) {
      State = sp->next_state;
      PatternNumber = States[State].start;
    }
  }else {
    if (PatternNumber > sp->end) {
      ActionFlag = ACT_NONE;
      State = sp->next_state;
      PatternNumber = States[State].start;
    }
  }

  flush = Draw(Pattern[PatternNumber].num);

  if (!UseWM) {
    if (ptx_back != Pattern[PatternNumber].x
	|| pty_back != Pattern[PatternNumber].y) {
      ptx_back = Pattern[PatternNumber].x;
      pty_back = Pattern[PatternNumber].y;
      XMoveWindow(MyDisplay, MyWindow, Myx + ptx_back, Myy + pty_back);
      flush = True;
    }
  }

  if (flush) XFlush(MyDisplay);

  pause();

  PatternNumber++;
}

#define	N_CHILD	10
typedef	struct {
  Window	window;
  Window	child [N_CHILD];
  Window	child2[N_CHILD];
}FOCUS;

FOCUS	MyFocus     = {None, None, None};
FOCUS	MyFocusBack = {None, None, None};
FOCUS	MyFocusBack2= {None, None, None};

Bool
ErrWindow(win)
     Window	win;
{
  int	i;

  if (win == None) return (True);

  if (win == MyFocus.window) {
    if (FocusDebug) fprintf(stderr, "<%x>\n", win);		return (False);
  }else if (win == MyFocusBack.window) {
    if (FocusDebug) fprintf(stderr, "b<%x>\n", win);		return (False);
  }else if (win == MyFocusBack2.window) {
    if (FocusDebug) fprintf(stderr, "bb<%x>\n", win);		return (False);
  }
  for (i = 0; i < N_CHILD; i++) {
    if (win == MyFocus.child[i]) {
      if (FocusDebug) fprintf(stderr, "child<%x>\n", win);	return (False);
    }else if (win == MyFocus.child2[i]) {
      if (FocusDebug) fprintf(stderr, "child2<%x>\n", win);	return (False);
    }else if (win == MyFocusBack.child[i]) {
      if (FocusDebug) fprintf(stderr, "bchild<%x>\n", win);	return (False);
    }else if (win == MyFocusBack.child2[i]) {
      if (FocusDebug) fprintf(stderr, "bchild2<%x>\n", win);	return (False);
    }else if (win == MyFocusBack2.child[i]) {
      if (FocusDebug) fprintf(stderr, "bbchild<%x>\n", win);	return (False);
    }else if (win == MyFocusBack2.child2[i]) {
      if (FocusDebug) fprintf(stderr, "bbchild2<%x>\n",win);	return (False);
    }
  }
  return (True);
}

int
MyErrorHandler(display, myerr)
     Display		*display;
     XErrorEvent	*myerr;
{
  if (ErrWindow(myerr->resourceid)) {
    char	msg[256];

    XGetErrorText(display, myerr->error_code, msg, sizeof(msg));
    Error("Error code %s", msg);
    Error("Resouce id %x", myerr->resourceid);
    exit(1);
  }
  MyFocusBack.window = None;
  return (0);
}

KeySym
GetKeysym(key)
     char	*key;
{
  KeySym	sym = XStringToKeysym(key);

  if (sym == NoSymbol)	ErrorExit("not found keysym '%s'", key);
  return (sym);
}

Bool
CheckEvent()
{
  static int	drag_x = -1, drag_y = -1;
  XEvent	event;
  Bool		flag = True;
  int	ix = 0;

  while (XEventsQueued(MyDisplay, QueuedAfterReading) > 0) {
    XNextEvent(MyDisplay, &event);
    switch(event.type) {
    case DestroyNotify:
      if (event.xdestroywindow.window == MyFocusBack.window) {
	MyFocusBack.window = None;
      }else {
	int	i;
	for (i = 0; i < N_CHILD; i++) {
	  if (event.xdestroywindow.window == MyFocusBack.child[i]) {
	    MyFocusBack.child[i] = None;
	    break;
	  }else if (event.xdestroywindow.window == MyFocusBack.child2[i]) {
	    MyFocusBack.child2[i] = None;
	    break;
	  }
	}
      }
      if (FocusDebug) {
	fprintf(stderr, "destory(%x)%s\n", event.xdestroywindow.window,
		(event.xdestroywindow.window==MyFocusBack.window) ? "-":"");
      }
      break;
    case KeyPress:
      if (FocusDebug) {
	fprintf(stderr, "win=%x, keycode=%d, keysym=%x\n",
		event.xkey.window, event.xkey.keycode,
		XKeycodeToKeysym(MyDisplay, event.xkey.keycode, ix) );
      }
      if (XKeycodeToKeysym(MyDisplay, event.xkey.keycode, ix) == ActionKeysym){
	ActionFlag = ACT_KEY;
      }
      break;
    case ButtonPress:
      if (event.xbutton.button == Button1) {
	drag_x = event.xbutton.x;
	drag_y = event.xbutton.y;
      }else if (event.xbutton.button == Button2) {
	XMapRaised(MyDisplay, MyWindow);
      }else {
	flag = False;
      }
      break;
    case ButtonRelease:
      drag_x = drag_y = -1;
      break;
    case MotionNotify:
      if (drag_x >= 0 && drag_y >= 0) {
	while (XCheckWindowEvent(MyDisplay, MyWindow,
				 PointerMotionMask, &event)) {
	}
	GetPointerPosition(MyWindow, &Myx, &Myy);
	Myx -= drag_x;
	Myy -= drag_y;
	XMoveWindow(MyDisplay, MyWindow, Myx, Myy);
      }
      break;
    case MappingNotify:
      XRefreshKeyboardMapping((XMappingEvent*)&event);
      ActionKeysym = GetKeysym(ActionKey);
      break;
/**
    case ConfigureNotify:
      if (UseWM) {
	if (event.xconfigure.window == MyWindow && State == IDLE) {
	  Myx = event.xconfigure.x;
	  Myy = event.xconfigure.y;
	  if (Debug) fprintf(stderr, "%d %d %d\n",
			     Myx, Myy, event.xconfigure.send_event);
	}
      }
      break;
**/
    default:
      break;
    }
  }

  if (Rhime) {
    static int	focus_check_count = 0;

    if (++focus_check_count >= FocusCheckCountMax) {
      int	rever_to;

      focus_check_count = 0;

      XGetInputFocus(MyDisplay, &MyFocus.window, &rever_to);

      if (   MyFocus.window != MyFocusBack.window
	  && MyFocus.window != None
	  && MyFocus.window != PointerRoot
	  && MyFocus.window != MyWindow) {
	Window	root, parent, *children, *children2;
	unsigned int	nchildren, nchildren2;
	unsigned int	i, j;

	if (FocusDebug) fprintf(stderr, "<%x", MyFocus.window);
	XSelectInput(MyDisplay, MyFocus.window, FOCUS_EVENT_MASK);

	for ( i = 0; i < N_CHILD; i++) MyFocus.child [i] = None;
	for ( j = 0; j < N_CHILD; j++) MyFocus.child2[j] = None;

	if (XQueryTree(MyDisplay, MyFocus.window,
		       &root, &parent, &children, &nchildren)) {
	  for (i = j = 0; i < MIN(N_CHILD, nchildren); i++) {
	    MyFocus.child[i] = children[i];
	    XSelectInput(MyDisplay, children[i], FOCUS_EVENT_MASK);
	    if (FocusDebug) fprintf(stderr, ",%x", children[i]);

	    if (XQueryTree(MyDisplay, children[i],
			   &root, &parent, &children2, &nchildren2)) {
	      for ( ; j < MIN(N_CHILD, nchildren2); j++) {
		MyFocus.child2[j] = children2[j];
		XSelectInput(MyDisplay, children2[j], FOCUS_EVENT_MASK);
		if (FocusDebug) fprintf(stderr, ";%x", children2[j]);
	      }
	      XFree(children2);
	    }
	  }
	  XFree(children);
	}
	if (FocusDebug) fprintf(stderr, ">\n");

	if (FocusDebug) fprintf(stderr, "(");
	if (MyFocusBack.window != None) {
	  XSelectInput(MyDisplay, MyFocusBack.window, 0);
	  if (FocusDebug) fprintf(stderr, "%x", MyFocusBack.window);
	}
	for (i = 0; i < N_CHILD; i++) {
	  if (MyFocusBack.child [i] != None) {
	    XSelectInput(MyDisplay, MyFocusBack.child [i], 0);
	    if (FocusDebug) fprintf(stderr, ",%x", MyFocusBack.child [i]);
	  }
	  if (MyFocusBack.child2[i] != None) {
	    XSelectInput(MyDisplay, MyFocusBack.child2[i], 0);
	    if (FocusDebug) fprintf(stderr, ";%x", MyFocusBack.child2[i]);
	  }
	}
	if (FocusDebug) fprintf(stderr, ")\n");

	MyFocusBack2.window = MyFocusBack.window;
	MyFocusBack.window = MyFocus.window;
	for (i = 0; i < N_CHILD; i++) {
	  MyFocusBack2.child [i] = MyFocusBack.child [i];
	  MyFocusBack2.child2[i] = MyFocusBack.child2[i];
	  MyFocusBack.child [i] = MyFocus.child [i];
	  MyFocusBack.child2[i] = MyFocus.child2[i];
	}
      }
    }
  }

  if (Biff) {
    static int	mail_check_count = INT_MAX - 1;
    if (++mail_check_count >= MailCheckCountMax) {
      mail_check_count = 0;
      if (CheckMail()) ActionFlag = ACT_MAIL;
    }
  }
  return (flag);
}

void
Animation()
{
  struct itimerval	itime;

  timerclear(&itime.it_interval);
  timerclear(&itime.it_value);

  itime.it_interval.tv_usec = INTERVAL_TIME_MS*1000L;
  itime.it_value.tv_usec    = INTERVAL_TIME_MS*1000L;

  setitimer(ITIMER_REAL, &itime, 0);

  FocusCheckCountMax = FOCUS_CHECK_INTERVAL_TIME_MS / INTERVAL_TIME_MS;
  MailCheckCountMax  = MAIL_CHECK_INTERVAL_TIME_MS  / INTERVAL_TIME_MS;
  do {
    DrawPattern();
  } while (CheckEvent());
}

void
AllocColors()
{
  Colormap	colormap = DefaultColormap(MyDisplay, MyScreen);
  XColor	color;
  XGCValues	values;
  COLOR	*cp = *Color;
  int	i;

  for (i = 0; i < NCOLORS; i++, cp++) {
    char	*name = cp->name;

    if (Background && i == 0) name = Background;

    if (XParseColor(MyDisplay, colormap, name, &color)) {
      if (XAllocColor(MyDisplay, colormap, &color) == 0) {
	ErrorExit("cannot allocate color '%s'", name);
      }

      values.foreground = color.pixel;
      cp->GC = XCreateGC(MyDisplay, MyWindow, GCForeground, &values);
    }else {
      ErrorExit("cannot parse color '%s'", name);
    }
  }
}

void
InitScreen()
{
  Window		root;
  XSizeHints		sizehints;
  XSetWindowAttributes	attributes;
  unsigned long		mask;
  int			eventbase, errorbase;
  unsigned long   black;

  if ((MyDisplay = XOpenDisplay(DisplayName)) == NULL) {
    if (!DisplayName || (DisplayName && *DisplayName == '\0')) {
      char	*p = (char *)getenv("DISPLAY");
      ErrorExit("cannot open display '%s'", (p ? p : "(null)"));
    }else {
      ErrorExit("cannot open display '%s'", DisplayName);
    }
  }

  ActionKeysym = GetKeysym(ActionKey);

#ifdef	SHAPE
  if (!NoShape && !XShapeQueryExtension(MyDisplay, &eventbase, &errorbase)) {
    Error("Display not suported shape extension");
    NoShape = True;
  }
#endif/*SHAPE*/

  MyScreen = DefaultScreen(MyDisplay);
  MyDepth  = DefaultDepth(MyDisplay, MyScreen);
  root     = RootWindow(MyDisplay, MyScreen);

  if (Geometry) {
    char	ge[256];
    sprintf(ge, "%dx%d+0+0", WIDTH, HEIGHT);
    if (XGeometry(MyDisplay, MyScreen, Geometry, ge, 1, 1, 1, 0, 0, &Myx, &Myy,
		  &sizehints.width, &sizehints.height) & (XValue|YValue)
	== 0) {
      Geometry = NULL;
    }
  }
  if (!Geometry) {
    GetPointerPosition(root, &Myx, &Myy);
    Myx -= (WIDTH /2);
    Myy -= (HEIGHT/2);
  }
  mask = CWSaveUnder | CWOverrideRedirect;
  attributes.save_under        = True;
  attributes.override_redirect = !UseWM;

  MyWindow = XCreateWindow(MyDisplay, root, Myx, Myy, WIDTH, HEIGHT + H_OFF,
			   0, MyDepth, InputOutput, CopyFromParent,
			   mask, &attributes);

  sizehints.flags = PMinSize | PMaxSize;
  sizehints.min_width  = sizehints.max_width  = WIDTH;
  sizehints.min_height = sizehints.max_height = HEIGHT + H_OFF;

  XSetStandardProperties(MyDisplay, MyWindow, ProgramName, ProgramName, None,
			 NULL, 0, &sizehints);

/*  black = BlackPixel(MyDisplay, MyScreen);
  XSetWindowBackgroundPixmap(MyDisplay, MyWindow, black); perfomance bad! */
  XSetWindowBackgroundPixmap(MyDisplay, MyWindow, None);
  AllocColors();

  XSelectInput(MyDisplay, MyWindow, EVENT_MASK);
  XSelectInput(MyDisplay, root, KeyPressMask);

  XFlush(MyDisplay);

  XSetErrorHandler(MyErrorHandler);
}


char *OptionsAre[] = {
  "-help              Print usage message and exit\n",
  "-display <host:n>  Specify the host and display number\n",
  "-geometry <+X+Y>   Specify the geometry\n",
  "-key <keyname>     Specify the keysym of the special key\n",
  "-nokey             Don't check for the special key\n",
#ifdef	SHAPE
  "-noshape           Don't use shape extension\n",
#endif/*SHAPE*/
  "-bg <color>        Specify the background color\n",
  "[-N | -B | -D]     Draw in normal, brighter, or darker colors\n",
  "-<statenumber>     Specify the action state\n",
  "-use_wm            Use window manager\n",
  "-audio <audiofile> Specify audio file\n",
  " [-audev <dev>|-aucmd <cmd>]\n",
  "                    Specify audio device or command\n",
  " -showaudio         the same as ``-aucmd showaudio''\n",
  "-biff              Enable biff feature\n",
  " -file <mailfile>   Specify the mail file\n",
  " -update <sec>      Specify the mail polling interval\n",
  " -nobell            Don't ring the bell when mails arrive\n",
  NULL,
};

void
PrintUsage()
{
  char	**p = OptionsAre;
  fprintf(stderr, "%s", Copyright);
  fprintf(stderr, "usage: %s [<options>] [<filename.xhm>]\n", ProgramName);
  fprintf(stderr, "  options are:\n");
  while (*p) fprintf(stderr, "    %s", *p++);
  return;
}

#define	MissingArg(argv)	ErrorExit("missing argument to %s", (argv))
#define	CheckArg(argc, argv)	do{if((argc)<= 0) MissingArg(argv);}while(0)

void
GetOptions(argc, argv)
     int	argc;
     char	**argv;
{
  Bool	bell = True;

  ProgramName = *argv;

  while (--argc > 0) {
    argv++;
    if (strcmp(*argv, "-display") == 0) {
      CheckArg(--argc, argv);	DisplayName = *++argv;
    }else if (strcmp(*argv, "-geometry") == 0) {
      CheckArg(--argc, *argv);	Geometry = *++argv;
    }else if (strcmp(*argv, "-key") == 0) {
      CheckArg(--argc, *argv);	ActionKey = *++argv;
    }else if (strcmp(*argv, "-bg") == 0) {
      CheckArg(--argc, *argv);	Background = *++argv;
#ifdef	SHAPE
    }else if (strcmp(*argv, "-noshape") == 0) {
      NoShape = True;
    }else if (strcmp(*argv, "-shape") == 0) {
      NoShape = False;
#endif/*SHAPE*/
    }else if (strcmp(*argv, "-use_wm") == 0) {
      UseWM = True;	NoShape = True;
    }else if (strcmp(*argv, "-audio") == 0) {
      Audio = AUD_DEV;
      CheckArg(--argc, *argv);	AudioDataName = *++argv;
    }else if (strcmp(*argv, "-audev") == 0) {
      Audio = AUD_DEV;
      CheckArg(--argc, *argv);	AudioDevice = *++argv;
    }else if (strcmp(*argv, "-max_ausize") == 0) {
      CheckArg(--argc, *argv);	MAX_AUSIZE = atoi(*++argv);
    }else if (strcmp(*argv, "-showaudio") == 0) {
      Audio = AUD_CMD;
    }else if (strcmp(*argv, "-noshowaudio") == 0) {
      Audio = AUD_DEV;
    }else if (   strcmp(*argv, "-nokey" ) == 0
	      || strcmp(*argv, "-nohime") == 0) {
      Rhime = False;
    }else if (   strcmp(*argv, "-aucmd"   ) == 0
	      || strcmp(*argv, "-mscript" ) == 0) {
      Audio = AUD_CMD;
      CheckArg(--argc, *argv);	AudioCommand = *++argv;
    }else if (strcmp(*argv, "-biff") == 0) {
      Biff = True;
    }else if (strcmp(*argv, "-nobiff") == 0) {
      Biff = False;
    }else if (strcmp(*argv, "-nobell") == 0) {
      bell = False;
    }else if (   strcmp(*argv, "-update") == 0
	      || strcmp(*argv, "-mtime" ) == 0) {
      Biff = True;
      CheckArg(--argc, *argv);
      MAIL_CHECK_INTERVAL_TIME_MS = atoi(*++argv) * 1000;
    }else if (   strcmp(*argv, "-file") == 0
	      || strcmp(*argv, "-mail") == 0) {
      Biff = True;
      CheckArg(--argc, *argv);	MailPathArg = *++argv;
    }else if (strcmp(*argv, "-debug") == 0) {
      Debug = True;
    }else if (strcmp(*argv, "-focusdebug") == 0) {
      FocusDebug = True;
    }else if (strcmp(*argv, "-N") == 0) {
      Color = &ColorN;
    }else if (strcmp(*argv, "-B") == 0) {
      Color = &ColorB;
    }else if (strcmp(*argv, "-D") == 0) {
      Color = &ColorD;
    }else if (strcmp(*argv, "-") == 0 && argc == 1) {
      DataName = "-";
    }else if (strncmp(*argv, "-", 1) == 0) {
      if ('0' <= *(*argv + 1) && *(*argv + 1) <= '9') {
	ActionState = atoi(*argv + 1);
      }else {
	PrintUsage(ProgramName);
	exit(0);
      }
    }else if (argc == 1) {
      DataName = *argv;
    }
  }

  if (Biff && bell && Audio == AUD_NONE) Audio = AUD_BELL;

  GetData(DataName);
}

void
ResetChild()
{
  int	stat;
  wait(&stat);
#ifdef	NO_SIGACTION
#if defined(SYSV) || defined(XSYSV_SIG)
  signal(SIGCHLD, ResetChild);
#endif/*SYSV || XSYSV_SIG*/
#endif/*NO_SIGACTION*/
  if (Debug) fprintf(stderr, "SIGCHLD caught\n");
}

void
ResetAlarm()
{
#ifdef	NO_SIGACTION
#if defined(SYSV) || defined(XSYSV_SIG)
  signal(SIGALRM, ResetAlarm);
#endif/*SYSV || XSYSV_SIG*/
#endif/*NO_SIGACTION*/
}

void
Exit()
{
  if (MyDisplay) {
    XDestroyWindow(MyDisplay, MyWindow);
    XCloseDisplay(MyDisplay);
  }
  exit(0);
}

void
main(argc, argv)
     int	argc;
     char	*argv[];
{
  GetOptions(argc, argv);

  InitScreen();
  MakePixmap();

  if (Biff) GetMailPath();
  if (Audio) ReadAudioFile();

#ifdef	NO_SIGACTION
  signal(SIGALRM, ResetAlarm);
  signal(SIGCHLD, ResetChild);
#else
  {
    static struct sigaction alrm, chld;
    alrm.sa_handler = ResetAlarm;
    chld.sa_handler = ResetChild;
    sigaction(SIGALRM, &alrm, NULL);
    sigaction(SIGCHLD, &chld, NULL);
  }
#endif/*NO_SIGACTION*/

  signal(SIGINT,  Exit);
  signal(SIGTERM, Exit);
  signal(SIGQUIT, Exit);

  XMapWindow(MyDisplay, MyWindow);
  Animation();

  Exit();
}
